// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from soccer_object_msgs:msg/RobotArray.idl
// generated code does not contain a copyright notice
#include "soccer_object_msgs/msg/detail/robot_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `robots`
#include "soccer_object_msgs/msg/detail/robot__functions.h"

bool
soccer_object_msgs__msg__RobotArray__init(soccer_object_msgs__msg__RobotArray * msg)
{
  if (!msg) {
    return false;
  }
  // robots
  if (!soccer_object_msgs__msg__Robot__Sequence__init(&msg->robots, 0)) {
    soccer_object_msgs__msg__RobotArray__fini(msg);
    return false;
  }
  return true;
}

void
soccer_object_msgs__msg__RobotArray__fini(soccer_object_msgs__msg__RobotArray * msg)
{
  if (!msg) {
    return;
  }
  // robots
  soccer_object_msgs__msg__Robot__Sequence__fini(&msg->robots);
}

soccer_object_msgs__msg__RobotArray *
soccer_object_msgs__msg__RobotArray__create()
{
  soccer_object_msgs__msg__RobotArray * msg = (soccer_object_msgs__msg__RobotArray *)malloc(sizeof(soccer_object_msgs__msg__RobotArray));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(soccer_object_msgs__msg__RobotArray));
  bool success = soccer_object_msgs__msg__RobotArray__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
soccer_object_msgs__msg__RobotArray__destroy(soccer_object_msgs__msg__RobotArray * msg)
{
  if (msg) {
    soccer_object_msgs__msg__RobotArray__fini(msg);
  }
  free(msg);
}


bool
soccer_object_msgs__msg__RobotArray__Sequence__init(soccer_object_msgs__msg__RobotArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  soccer_object_msgs__msg__RobotArray * data = NULL;
  if (size) {
    data = (soccer_object_msgs__msg__RobotArray *)calloc(size, sizeof(soccer_object_msgs__msg__RobotArray));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = soccer_object_msgs__msg__RobotArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        soccer_object_msgs__msg__RobotArray__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
soccer_object_msgs__msg__RobotArray__Sequence__fini(soccer_object_msgs__msg__RobotArray__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      soccer_object_msgs__msg__RobotArray__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

soccer_object_msgs__msg__RobotArray__Sequence *
soccer_object_msgs__msg__RobotArray__Sequence__create(size_t size)
{
  soccer_object_msgs__msg__RobotArray__Sequence * array = (soccer_object_msgs__msg__RobotArray__Sequence *)malloc(sizeof(soccer_object_msgs__msg__RobotArray__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = soccer_object_msgs__msg__RobotArray__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
soccer_object_msgs__msg__RobotArray__Sequence__destroy(soccer_object_msgs__msg__RobotArray__Sequence * array)
{
  if (array) {
    soccer_object_msgs__msg__RobotArray__Sequence__fini(array);
  }
  free(array);
}
